# -*- coding: iso-8859-15 -*-

###################
# TP 7 : Dijkstra #
###################

class Matrice:
    # Cre une matrice de taille nxn dont tous les coefficient vallent d
    def __init__(self,n,d=0):
        self.n=n
        self.coeffs=[]
        for l in range(n):
            self.coeffs.append([d]*n)

    # Permet d'afficher la matrice avec print
    def __repr__(self):
        str=""
        for l in range(self.n):
            for c in range(self.n):
                str=str+repr(self.coeffs[l][c])+'\t'
            str=str+'\n'
        return str

    # Retourne la valeur du coefficient (l,c) avec 1<=l<=n et 1<=c<=n
    def lire(self,l,c):
        if l<1 or l>self.n or c<1 or c>self.n:
            raise AttributeError("Indices coefficient matrice invalides")
        return self.coeffs[l-1][c-1]

    # Affecte une valeur au coefficient (l,c) avec 1<=l<=n et 1<=c<=n
    def ecrire(self,l,c,v):
        if l<1 or l>self.n or c<1 or c>self.n:
            raise AttributeError("Indices coefficient matrice invalides")
        self.coeffs[l-1][c-1]=v

# Nous allons reprsent les
#  - graphes non orient
#  - graphes orient
# grce a leurs matrices d'ajacences.
# Ainsi lorsqu'on parlera du graph G, on supposera que G a la martice d'adjacence du grpahe G

#------------
# Exercice 1
#------------

# 1. Ecrire une fonction ajoute_arete(G,i,j,e) qui ajoute une arete i -- j avec l'etiquette e dans le graphe orient G

def ajoute_arete(G,i,j,e):
    G.ecrire(i,j,e)

# 2. Ecrire une fonction ajoute_plusieurs_aretes (G,l) qui tant donne une liste de couple (i,j,e
#    ajoute l'arete i -> j  G tiquetee e. Exemple : ajoulte_plusieurs_aretes(G,[(1,2,10),(4,3,7)])

def ajoute_plusieures_aretes(G,l):
    for (i,j,e) in l:
        ajoute_arete(G,i,j,e)

# 3. Crer le graphe oriente de l'exercice 2 du TD 5

G=Matrice(6)
# 1 -> S, 2 -> A, 3 -> C, 4 -> E, 5 -> D, 6 -> B  
ajoute_plusieures_aretes(G,[(1,2,3),(1,3,5),(1,6,1),(2,3,2),(3,4,5),(3,5,2),(3,6,1),(5,4,2),(5,3,3),(6,2,1),(6,4,15),(6,5,6)])

#------------
# Exercice 2
#------------

# 1. Ecrire une fonctiod dijkstra_moore(G,d,a) qui tant donn un graphe G etiquete caclul 
#    l'aide de l'algorithm de Dijkstra-Moore le plus court chemin entre les sommets i et j.

def dijkstra_moore(G,d,a):
    n=G.n
    cout=[(None,None)]*(G.n+1)
    visite=[False]*(G.n+1)
    cout[d]=(0,None)
    while True:
        #Recherche du sommet non visite avec cout minimum
        m=0
        cm=None
        for i in range(1,n+1):
            if not visite[i]:
                if cm==None:
                    m=i
                    cm=cout[m][0]
                else:
                    if cout[i][0]!=None and cout[i][0]<cm:
                        m=i
                        cm=cout[m][0]
        #Le sommet le moins char non visite est m il a cm comme cout
        if m==a:
            #Si m est le sommet a, c'est fini
            print("Le cout minimal pour aller de",d,"",a,"est",cm)
            print("Un tel cout est realise par le chemin")
            chemin=repr(a)
            i=a
            while i!=d:
                (c,i)=cout[i]
                chemin=" -> "+chemin
                chemin=repr(i)+chemin
            print(chemin)
            return
        for i in range(1,n+1):
            v=G.lire(m,i)
            if v>0:
                c=cm+v
                if cout[i][0]==None or cout[i][0]>c:
                    cout[i]=(c,m)
        visite[m]=True
        
            
# 2. Tester votre algorithme sur le graphe cr  l'exercice prcdent.

if __name__=="__main__":
    dijkstra_moore(G,1,4)
